<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (158)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="character-classes">Character classes</h1>
    <p>
      Consider a practical task – we have a phone number like
      <code>"+7(903)-123-45-67"</code>, and we need to turn it into pure
      numbers: <code>79031234567</code>.
    </p>
    <p>
      To do so, we can find and remove anything that’s not a number. Character
      classes can help with that.
    </p>
    <p>
      A <em>character class</em> is a special notation that matches any symbol
      from a certain set.
    </p>
    <p>
      For the start, let’s explore the “digit” class. It’s written as
      <code>pattern:\d</code> and corresponds to “any single digit”.
    </p>
    <p>For instance, let’s find the first digit in the phone number:</p>
    <p>```js run let str = “+7(903)-123-45-67”;</p>
    <p>let regexp = /;</p>
    <p>alert(str.match(regexp)); // 7 ```</p>
    <p>
      Without the flag <code>pattern:g</code>, the regular expression only looks
      for the first match, that is the first digit <code>pattern:\d</code>.
    </p>
    <p>Let’s add the <code>pattern:g</code> flag to find all digits:</p>
    <p>```js run let str = “+7(903)-123-45-67”;</p>
    <p>let regexp = /g;</p>
    <p>alert(str.match(regexp)); // array of matches: 7,9,0,3,1,2,3,4,5,6,7</p>
    <p>
      // let’s make the digits-only phone number of them:
      alert(str.match(regexp).join("")); // 79031234567 ```
    </p>
    <p>
      That was a character class for digits. There are other character classes
      as well.
    </p>
    <p>Most used are:</p>
    <dl>
      <dt><code>pattern:\d</code> (“d” is from “digit”)</dt>
      <dd>A digit: a character from <code>0</code> to <code>9</code>.</dd>
      <dt><code>pattern:\s</code> (“s” is from “space”)</dt>
      <dd>
        A space symbol: includes spaces, tabs <code>\t</code>, newlines
        <code>\n</code> and few other rare characters, such as <code>\v</code>,
        <code>\f</code> and <code>\r</code>.
      </dd>
      <dt><code>pattern:\w</code> (“w” is from “word”)</dt>
      <dd>
        A “wordly” character: either a letter of Latin alphabet or a digit or an
        underscore <code>_</code>. Non-Latin letters (like cyrillic or hindi) do
        not belong to <code>pattern:\w</code>.
      </dd>
    </dl>
    <p>
      For instance, <code>pattern:\d\s\w</code> means a “digit” followed by a
      “space character” followed by a “wordly character”, such as
      <code>match:1 a</code>.
    </p>
    <p>
      <strong
        >A regexp may contain both regular symbols and character
        classes.</strong
      >
    </p>
    <p>
      For instance, <code>pattern:CSS\d</code> matches a string
      <code>match:CSS</code> with a digit after it:
    </p>
    <p>```js run let str = “Is there CSS4?”; let regexp = /CSS;</p>
    <p>alert(str.match(regexp)); // CSS4 ```</p>
    <p>Also we can use many character classes:</p>
    <p>
      <code
        >js run alert("I love HTML5!".match(/\s\w\w\w\w\d/)); // ' HTML5'</code
      >
    </p>
    <p>
      The match (each regexp character class has the corresponding result
      character):
    </p>
    <p><img src="love-html5-classes.svg" /></p>
    <h2 id="inverse-classes">Inverse classes</h2>
    <p>
      For every character class there exists an “inverse class”, denoted with
      the same letter, but uppercased.
    </p>
    <p>
      The “inverse” means that it matches all other characters, for instance:
    </p>
    <dl>
      <dt><code>pattern:\D</code></dt>
      <dd>
        Non-digit: any character except <code>pattern:\d</code>, for instance a
        letter.
      </dd>
      <dt><code>pattern:\S</code></dt>
      <dd>
        Non-space: any character except <code>pattern:\s</code>, for instance a
        letter.
      </dd>
      <dt><code>pattern:\W</code></dt>
      <dd>
        Non-wordly character: anything but <code>pattern:\w</code>, e.g a
        non-latin letter or a space.
      </dd>
    </dl>
    <p>
      In the beginning of the chapter we saw how to make a number-only phone
      number from a string like <code>subject:+7(903)-123-45-67</code>: find all
      digits and join them.
    </p>
    <p>```js run let str = “+7(903)-123-45-67”;</p>
    <p>alert(str.match(/g).join("")); // 79031234567 ```</p>
    <p>
      An alternative, shorter way is to find non-digits
      <code>pattern:\D</code> and remove them from the string:
    </p>
    <p>```js run let str = “+7(903)-123-45-67”;</p>
    <p>alert(str.replace(//g, "")); // 79031234567 ```</p>
    <h2 id="a-dot-is-any-character">A dot is “any character”</h2>
    <p>
      A dot <code>pattern:.</code> is a special character class that matches
      “any character except a newline”.
    </p>
    <p>For instance:</p>
    <p><code>js run alert("Z".match(/./)); // Z</code></p>
    <p>Or in the middle of a regexp:</p>
    <p>```js run let regexp = /CS.4/;</p>
    <p>
      alert(“CSS4”.match(regexp)); // CSS4 alert(“CS-4”.match(regexp)); // CS-4
      alert(“CS 4”.match(regexp)); // CS 4 (space is also a character) ```
    </p>
    <p>
      Please note that a dot means “any character”, but not the “absence of a
      character”. There must be a character to match it:
    </p>
    <p>
      <code
        >js run alert("CS4".match(/CS.4/)); // null, no match because there's no
        character for the dot</code
      >
    </p>
    <h3 id="dot-as-literally-any-character-with-s-flag">
      Dot as literally any character with “s” flag
    </h3>
    <p>
      By default, a dot doesn’t match the newline character <code>\n</code>.
    </p>
    <p>
      For instance, the regexp <code>pattern:A.B</code> matches
      <code>match:A</code>, and then <code>match:B</code> with any character
      between them, except a newline <code>\n</code>:
    </p>
    <p><code>js run alert("A\nB".match(/A.B/)); // null (no match)</code></p>
    <p>
      There are many situations when we’d like a dot to mean literally “any
      character”, newline included.
    </p>
    <p>
      That’s what flag <code>pattern:s</code> does. If a regexp has it, then a
      dot <code>pattern:.</code> matches literally any character:
    </p>
    <p><code>js run alert("A\nB".match(/A.B/s)); // A\nB (match!)</code></p>
    <p>
      ```<code>warn header="Not supported in IE" The</code>pattern:s` flag is
      not supported in IE.
    </p>
    <p>
      Luckily, there’s an alternative, that works everywhere. We can use a
      regexp like <code>pattern:[\s\S]</code> to match “any character” (this
      pattern will be covered in the article
      <a href="info:regexp-character-sets-and-ranges" class="uri"
        >info:regexp-character-sets-and-ranges</a
      >).
    </p>
    <p>
      <code>js run alert( "A\nB".match(/A[\s\S]B/) ); // A\nB (match!)</code>
    </p>
    <p>
      The pattern <code>pattern:[\s\S]</code> literally says: “a space character
      OR not a space character”. In other words, “anything”. We could use
      another pair of complementary classes, such as
      <code>pattern:[\d\D]</code>, that doesn’t matter. Or even the
      <code>pattern:[^]</code> – as it means match any character except nothing.
    </p>
    <p>
      Also we can use this trick if we want both kind of “dots” in the same
      pattern: the actual dot <code>pattern:.</code> behaving the regular way
      (“not including a newline”), and also a way to match “any character” with
      <code>pattern:[\s\S]</code> or alike. ````
    </p>
    <p>
      ```<code
        >warn header="Pay attention to spaces" Usually we pay little attention
        to spaces. For us strings</code
      >subject:1-5<code>and</code>subject:1 - 5` are nearly identical.
    </p>
    <p>
      But if a regexp doesn’t take spaces into account, it may fail to work.
    </p>
    <p>Let’s try to find digits separated by a hyphen:</p>
    <p>
      <code>js run alert( "1 - 5".match(/\d-\d/) ); // null, no match!</code>
    </p>
    <p>
      Let’s fix it adding spaces into the regexp <code>pattern:\d - \d</code>:
    </p>
    <p>
      <code
        >js run alert( "1 - 5".match(/\d - \d/) ); // 1 - 5, now it works // or
        we can use \s class: alert( "1 - 5".match(/\d\s-\s\d/) ); // 1 - 5, also
        works</code
      >
    </p>
    <p>
      <strong
        >A space is a character. Equal in importance with any other
        character.</strong
      >
    </p>
    <p>
      We can’t add or remove spaces from a regular expression and expect it to
      work the same.
    </p>
    <p>
      In other words, in a regular expression all characters matter, spaces too.
      ````
    </p>
    <h2 id="summary">Summary</h2>
    <p>There exist following character classes:</p>
    <ul>
      <li><code>pattern:\d</code> – digits.</li>
      <li><code>pattern:\D</code> – non-digits.</li>
      <li><code>pattern:\s</code> – space symbols, tabs, newlines.</li>
      <li><code>pattern:\S</code> – all but <code>pattern:\s</code>.</li>
      <li>
        <code>pattern:\w</code> – Latin letters, digits, underscore
        <code>'_'</code>.
      </li>
      <li><code>pattern:\W</code> – all but <code>pattern:\w</code>.</li>
      <li>
        <code>pattern:.</code> – any character if with the regexp
        <code>'s'</code> flag, otherwise any except a newline <code>\n</code>.
      </li>
    </ul>
    <p>…But that’s not all!</p>
    <p>
      Unicode encoding, used by JavaScript for strings, provides many properties
      for characters, like: which language the letter belongs to (if it’s a
      letter), is it a punctuation sign, etc.
    </p>
    <p>
      We can search by these properties as well. That requires flag
      <code>pattern:u</code>, covered in the next article.
    </p>
  </body>
</html>
